=== libnsfb-0.0.1/src/Makefile ===
# Sources
DIR_SOURCES := libnsfb.c cursor.c

include build/makefiles/Makefile.subdir
