=== libnsfb-0.0.1/test/Makefile ===
DIR_TEST_ITEMS := plottest:plottest.c;nsglobe.c frontend:frontend.c bezier:bezier.c path:path.c polygon:polygon.c polystar:polystar.c polystar2:polystar2.c

include build/makefiles/Makefile.subdir
