=== libcss-0.1.1/src/parse/Makefile ===
# Sources
DIR_SOURCES := parse.c language.c important.c propstrings.c

include build/makefiles/Makefile.subdir
