=== libcss-0.1.1/src/select/properties/Makefile ===
# Sources
DIR_SOURCES := helpers.c \
azimuth.c \
background_attachment.c \
background_color.c \
background_image.c \
background_position.c \
background_repeat.c \
border_bottom_color.c \
border_bottom_style.c \
border_bottom_width.c \
border_collapse.c \
border_left_color.c \
border_left_style.c \
border_left_width.c \
border_right_color.c \
border_right_style.c \
border_right_width.c \
border_spacing.c \
border_top_color.c \
border_top_style.c \
border_top_width.c \
bottom.c \
caption_side.c \
clear.c \
clip.c \
color.c \
content.c \
counter_increment.c \
counter_reset.c \
cue_after.c \
cue_before.c \
cursor.c \
direction.c \
display.c \
elevation.c \
empty_cells.c \
float.c \
font_family.c \
font_size.c \
font_style.c \
font_variant.c \
font_weight.c \
height.c \
left.c \
letter_spacing.c \
line_height.c \
list_style_image.c \
list_style_position.c \
list_style_type.c \
margin_bottom.c \
margin_left.c \
margin_right.c \
margin_top.c \
max_height.c \
max_width.c \
min_height.c \
min_width.c \
opacity.c \
orphans.c \
outline_color.c \
outline_style.c \
outline_width.c \
overflow.c \
padding_bottom.c \
padding_left.c \
padding_right.c \
padding_top.c \
page_break_after.c \
page_break_before.c \
page_break_inside.c \
pause_after.c \
pause_before.c \
pitch.c \
pitch_range.c \
play_during.c \
position.c \
quotes.c \
richness.c \
right.c \
speech_rate.c \
speak.c \
speak_header.c \
speak_numeral.c \
speak_punctuation.c \
stress.c \
table_layout.c \
text_align.c \
text_decoration.c \
text_indent.c \
text_transform.c \
top.c \
unicode_bidi.c \
vertical_align.c \
visibility.c \
voice_family.c \
volume.c \
white_space.c \
width.c \
windows.c \
word_spacing.c \
z_index.c

include build/makefiles/Makefile.subdir
