=== debian/changelog ===
netsurf (2.8-2) unstable; urgency=high

  * Fix user settings directory permissions (Closes: #659376) 
    Fixes: CVE-2012-0844

 -- Vincent Sanders <vince@debian.org>  Thu, 16 Feb 2012 10:59:13 +0000

netsurf (2.8-1) unstable; urgency=low

  * New upstream release
    - Fixes FTBFS on amd64 (Closes: #634427)
    - Fixes program abort on https links (Closes: #633506)
  * Improve short description (Closes: #625220)
  * Provide vcs-svn header (Closes: #638502)

 -- Vincent Sanders <vince@debian.org>  Thu, 22 Sep 2011 00:50:59 +0100
